{
*****************************
*                           *
* Author: Adrian M. Hanslik *
* Date: 08. October 1999    *
* Title: AMHTipDialog       *
* Version: 1.0              *
*                           *
*****************************
}

unit AMHTipDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, AMHTipDialogUnit;

type
  TAMHTipDialog = class(TComponent)
  private
    { Private-Deklarationen }
    FShowAtStart: boolean;
    FTips: TStringList;
    FTitleAlignment: TAlignment;
    FTitleFont: TFont;
    FTitleLabel: String;
    FTitleLayout: TTextLayout;
    procedure SetShowAtStart(Value: boolean);
    procedure SetTips(Value: TStringList);
    procedure SetTitleAlignment(Value: TAlignment);
    procedure SetTitleFont(Value: TFont);
    procedure SetTitleLabel(Value: String);
    procedure SetTitleLayout(Value: TTextLayout);
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AnOwner: TComponent); override;
    destructor Destroy; override;
    function Execute: boolean;
  published
    { Published-Deklarationen }
    property ShowAtStart: boolean read FShowAtStart write SetShowAtStart;
    property Tips: TStringList read FTips write SetTips;
    property TitleAlignment: TAlignment read FTitleAlignment write SetTitleAlignment;
    property TitleFont: TFont read FTitleFont write SetTitleFont;
    property TitleLabel: String read FTitleLabel write SetTitleLabel;
    property TitleLayout: TTextLayout read FTitleLayout write SetTitleLayout;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('AMH Free', [TAMHTipDialog]);
end;

constructor TAMHTipDialog.Create(AnOwner: TComponent);
begin
  inherited Create(AnOwner);
  FTips := TStringList.Create;
  FTitleFont := TFont.Create;
end;

destructor TAMHTipDialog.Destroy;
begin
  FTitleFont.Free;
  FTips.Free;
  inherited Destroy;
end;

function TAMHTipDialog.Execute: boolean;
var
  AMHTipDialog: TAMHTipDialogForm;
begin
  try
    AMHTipDialog := TAMHTipDialogForm.Create(Application);
  except
    on Error: Exception do begin
       MessageBeep(0);
       Exit;
    end;
  end;
  with AMHTipDialog do begin
       Label1.Font.Assign(FTitleFont);
       Label1.Alignment := FTitleAlignment;
       Label1.Layout := FTitleLayout;
       Label1.Caption := FTitleLabel;
       Label3.Caption := '';
       Tips.Assign(FTips);
       CheckBox.Checked := FShowAtStart;
       try
         ShowModal;
         FShowAtStart := CheckBox.Checked;
       finally
         Free;
       end;
  end;
end;

procedure TAMHTipDialog.SetShowAtStart(Value: boolean);
begin
  if Value <> FShowAtStart then
     FShowAtStart := Value;
end;

procedure TAMHTipDialog.SetTips(Value: TStringList);
begin
  if Value <> FTips then
     FTips.Assign(Value);
end;

procedure TAMHTipDialog.SetTitleAlignment(Value: TAlignment);
begin
  if Value <> FTitleAlignment then
     FTitleAlignment := Value;
end;

procedure TAMHTipDialog.SetTitleFont(Value: TFont);
begin
  if Value <> FTitleFont then
     FTitleFont.Assign(Value);
end;

procedure TAMHTipDialog.SetTitleLabel(Value: String);
begin
  if Value <> FTitleLabel then
     FTitleLabel := Value;
end;

procedure TAMHTipDialog.SetTitleLayout(Value: TTextLayout);
begin
  if Value <> FTitleLayout then
     FTitleLayout := Value;
end;

end.
